diff --git a/Changelog b/Changelog
index 9c7a533..8977ee6 100644
--- a/Changelog
+++ b/Changelog
@@ -34,6 +34,7 @@ version <next>:
 - floodfill video filter
 - pseudocolor video filter
 - FITS demuxer and decoder
+- FITS muxer and encoder

 version 3.3:
 - CrystalHD decoder moved to new decode API
diff --git a/doc/general.texi b/doc/general.texi
index 01402cb..1ea7984 100644
--- a/doc/general.texi
+++ b/doc/general.texi
@@ -592,7 +592,7 @@ following image formats are supported:
     @tab Digital Picture Exchange
 @item EXR          @tab   @tab X
     @tab OpenEXR
-@item FITS         @tab   @tab X
+@item FITS         @tab X @tab X
     @tab Flexible Image Transport System
 @item JPEG         @tab X @tab X
     @tab Progressive JPEG is not supported.
diff --git a/libavcodec/Makefile b/libavcodec/Makefile
index 42eec07..590410c 100644
--- a/libavcodec/Makefile
+++ b/libavcodec/Makefile
@@ -292,6 +292,7 @@ OBJS-$(CONFIG_FFV1_ENCODER)            += ffv1enc.o ffv1.o
 OBJS-$(CONFIG_FFWAVESYNTH_DECODER)     += ffwavesynth.o
 OBJS-$(CONFIG_FIC_DECODER)             += fic.o
 OBJS-$(CONFIG_FITS_DECODER)            += fitsdec.o fits.o
+OBJS-$(CONFIG_FITS_ENCODER)            += fitsenc.o
 OBJS-$(CONFIG_FLAC_DECODER)            += flacdec.o flacdata.o flac.o
 OBJS-$(CONFIG_FLAC_ENCODER)            += flacenc.o flacdata.o flac.o vorbis_data.o
 OBJS-$(CONFIG_FLASHSV_DECODER)         += flashsv.o
diff --git a/libavcodec/allcodecs.c b/libavcodec/allcodecs.c
index 8678ac2..7fe66f4 100644
--- a/libavcodec/allcodecs.c
+++ b/libavcodec/allcodecs.c
@@ -192,7 +192,7 @@ static void register_all(void)
     REGISTER_ENCDEC (FFV1,              ffv1);
     REGISTER_ENCDEC (FFVHUFF,           ffvhuff);
     REGISTER_DECODER(FIC,               fic);
-    REGISTER_DECODER(FITS,              fits);
+    REGISTER_ENCDEC (FITS,              fits);
     REGISTER_ENCDEC (FLASHSV,           flashsv);
     REGISTER_ENCDEC (FLASHSV2,          flashsv2);
     REGISTER_DECODER(FLIC,              flic);
diff --git a/libavcodec/fitsenc.c b/libavcodec/fitsenc.c
new file mode 100644
index 0000000..f67f3ad
--- /dev/null
+++ b/libavcodec/fitsenc.c
@@ -0,0 +1,130 @@
+/*
+ * FITS image encoder
+ * Copyright (c) 2017 Paras Chadha
+ *
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+/**
+ * @file
+ * FITS image encoder
+ *
+ * Specification: https://fits.gsfc.nasa.gov/fits_standard.html Version 3.0
+ *
+ * RGBA images are encoded as planes in RGBA order. So, NAXIS3 is 3 or 4 for them.
+ * Also CTYPE3 = 'RGB ' is added to the header to distinguish them from 3d images.
+ */
+
+#include "libavutil/intreadwrite.h"
+#include "avcodec.h"
+#include "bytestream.h"
+#include "internal.h"
+
+static int fits_encode_frame(AVCodecContext *avctx, AVPacket *pkt,
+                            const AVFrame *pict, int *got_packet)
+{
+    AVFrame * const p = (AVFrame *)pict;
+    uint8_t *bytestream, *bytestream_start, *ptr;
+    const uint16_t flip = (1 << 15);
+    uint64_t data_size = 0, padded_data_size = 0;
+    int ret, bitpix, naxis3 = 1, i, j, k, bytes_left;
+    int map[] = {2, 0, 1, 3}; // mapping from GBRA -> RGBA as RGBA is to be stored in FITS file..
+
+    switch (avctx->pix_fmt) {
+        case AV_PIX_FMT_GRAY8:
+        case AV_PIX_FMT_GRAY16BE:
+            map[0] = 0; // grayscale images should be directly mapped
+            if (avctx->pix_fmt == AV_PIX_FMT_GRAY8) {
+                bitpix = 8;
+            } else {
+                bitpix = 16;
+            }
+            break;
+        case AV_PIX_FMT_GBRP:
+        case AV_PIX_FMT_GBRAP:
+            bitpix = 8;
+            if (avctx->pix_fmt == AV_PIX_FMT_GBRP) {
+                naxis3 = 3;
+            } else {
+                naxis3 = 4;
+            }
+            break;
+        case AV_PIX_FMT_GBRP16BE:
+        case AV_PIX_FMT_GBRAP16BE:
+            bitpix = 16;
+            if (avctx->pix_fmt == AV_PIX_FMT_GBRP16BE) {
+                naxis3 = 3;
+            } else {
+                naxis3 = 4;
+            }
+            break;
+        default:
+            av_log(avctx, AV_LOG_ERROR, "unsupported pixel format\n");
+            return AVERROR(EINVAL);
+    }
+
+    data_size = (bitpix >> 3) * avctx->height * avctx->width * naxis3;
+    padded_data_size = ((data_size + 2879) / 2880 ) * 2880;
+
+    if ((ret = ff_alloc_packet2(avctx, pkt, padded_data_size, 0)) < 0)
+        return ret;
+
+    bytestream_start =
+    bytestream       = pkt->data;
+
+    for (k = 0; k < naxis3; k++) {
+        for (i = 0; i < avctx->height; i++) {
+            ptr = p->data[map[k]] + (avctx->height - i - 1) * p->linesize[map[k]];
+            if (bitpix == 16) {
+                for (j = 0; j < avctx->width; j++) {
+                    // subtracting bzero is equivalent to first bit flip
+                    bytestream_put_be16(&bytestream, AV_RB16(ptr) ^ flip);
+                    ptr += 2;
+                }
+            } else {
+                memcpy(bytestream, ptr, avctx->width);
+                bytestream += avctx->width;
+            }
+        }
+    }
+
+    bytes_left = padded_data_size - data_size;
+    memset(bytestream, 0, bytes_left);
+    bytestream += bytes_left;
+
+    pkt->size   = bytestream - bytestream_start;
+    pkt->flags |= AV_PKT_FLAG_KEY;
+    *got_packet = 1;
+
+    return 0;
+}
+
+AVCodec ff_fits_encoder = {
+    .name           = "fits",
+    .long_name      = NULL_IF_CONFIG_SMALL("Flexible Image Transport System"),
+    .type           = AVMEDIA_TYPE_VIDEO,
+    .id             = AV_CODEC_ID_FITS,
+    .encode2        = fits_encode_frame,
+    .pix_fmts       = (const enum AVPixelFormat[]) { AV_PIX_FMT_GBRAP16BE,
+                                                 AV_PIX_FMT_GBRP16BE,
+                                                 AV_PIX_FMT_GBRP,
+                                                 AV_PIX_FMT_GBRAP,
+                                                 AV_PIX_FMT_GBRP,
+                                                 AV_PIX_FMT_GRAY16BE,
+                                                 AV_PIX_FMT_GRAY8,
+                                                 AV_PIX_FMT_NONE },
+};
diff --git a/tests/fate/fits.mak b/tests/fate/fits.mak
index bd90c15..8202870 100644
--- a/tests/fate/fits.mak
+++ b/tests/fate/fits.mak
@@ -8,6 +8,17 @@ fate-fitsdec%: CMD = framecrc -i $(SRC) -pix_fmt $(PIXFMT)
 FATE_FITS_DEC_PIXFMT = gray gray16 gbrp gbrp16 gbrap16
 FATE_FITS += $(FATE_FITS_DEC_PIXFMT:%=fate-fitsdec-%)

+fate-fitsenc%: fate-fitsdec-multi
+fate-fitsenc%: PIXFMT = $(word 3, $(subst -, ,$(@)))
+fate-fitsenc%: SRC = $(TARGET_SAMPLES)/fits/fits-multi.fits
+fate-fitsenc%: CMD = framecrc -i $(SRC) -c:v fits -pix_fmt $(PIXFMT)
+
+FATE_FITS_ENC_PIXFMT = gray gray16be gbrp gbrap gbrp16be gbrap16be
+FATE_FITS_ENC-$(call ENCDEC, FITS, FITS) = $(FATE_FITS_ENC_PIXFMT:%=fate-fitsenc-%)
+
+FATE_FITS += $(FATE_FITS_ENC-yes)
+fate-fitsenc: $(FATE_FITS_ENC-yes)
+
 FATE_FITS-$(call DEMDEC, FITS, FITS) += $(FATE_FITS)

 FATE_SAMPLES_FFMPEG += $(FATE_FITS-yes)
diff --git a/tests/ref/fate/fitsenc-gbrap b/tests/ref/fate/fitsenc-gbrap
new file mode 100644
index 0000000..3e32fc6
--- /dev/null
+++ b/tests/ref/fate/fitsenc-gbrap
@@ -0,0 +1,10 @@
+#tb 0: 1/1
+#media_type 0: video
+#codec_id 0: fits
+#dimensions 0: 72x36
+#sar 0: 0/1
+0,          0,          0,        1,    11520, 0xeb0a0cc8
+0,          1,          1,        1,    11520, 0x9d7d8e4f
+0,          2,          2,        1,    11520, 0xd9e6afe7
+0,          3,          3,        1,    11520, 0x75bd7365
+0,          4,          4,        1,    11520, 0x86f107d1
diff --git a/tests/ref/fate/fitsenc-gbrap16be b/tests/ref/fate/fitsenc-gbrap16be
new file mode 100644
index 0000000..1f74f4e
--- /dev/null
+++ b/tests/ref/fate/fitsenc-gbrap16be
@@ -0,0 +1,10 @@
+#tb 0: 1/1
+#media_type 0: video
+#codec_id 0: fits
+#dimensions 0: 72x36
+#sar 0: 0/1
+0,          0,          0,        1,    23040, 0xfa4ff4f0
+0,          1,          1,        1,    23040, 0xf57102d4
+0,          2,          2,        1,    23040, 0x58e0294d
+0,          3,          3,        1,    23040, 0x8097502a
+0,          4,          4,        1,    23040, 0x65fd7b54
diff --git a/tests/ref/fate/fitsenc-gbrp b/tests/ref/fate/fitsenc-gbrp
new file mode 100644
index 0000000..4101a0e
--- /dev/null
+++ b/tests/ref/fate/fitsenc-gbrp
@@ -0,0 +1,10 @@
+#tb 0: 1/1
+#media_type 0: video
+#codec_id 0: fits
+#dimensions 0: 72x36
+#sar 0: 0/1
+0,          0,          0,        1,     8640, 0xf6b9f643
+0,          1,          1,        1,     8640, 0x250d77d9
+0,          2,          2,        1,     8640, 0x652595e5
+0,          3,          3,        1,     8640, 0x4b8e5963
+0,          4,          4,        1,     8640, 0xd8d611ab
diff --git a/tests/ref/fate/fitsenc-gbrp16be b/tests/ref/fate/fitsenc-gbrp16be
new file mode 100644
index 0000000..d4b043f
--- /dev/null
+++ b/tests/ref/fate/fitsenc-gbrp16be
@@ -0,0 +1,10 @@
+#tb 0: 1/1
+#media_type 0: video
+#codec_id 0: fits
+#dimensions 0: 72x36
+#sar 0: 0/1
+0,          0,          0,        1,    17280, 0x6b87eec5
+0,          1,          1,        1,    17280, 0x1bf0fc9a
+0,          2,          2,        1,    17280, 0xaf071b1e
+0,          3,          3,        1,    17280, 0xfbe941fb
+0,          4,          4,        1,    17280, 0xbbc26d01
diff --git a/tests/ref/fate/fitsenc-gray b/tests/ref/fate/fitsenc-gray
new file mode 100644
index 0000000..46eb76c
--- /dev/null
+++ b/tests/ref/fate/fitsenc-gray
@@ -0,0 +1,10 @@
+#tb 0: 1/1
+#media_type 0: video
+#codec_id 0: fits
+#dimensions 0: 72x36
+#sar 0: 0/1
+0,          0,          0,        1,     2880, 0xd2d83752
+0,          1,          1,        1,     2880, 0x77246e79
+0,          2,          2,        1,     2880, 0xdf480c1f
+0,          3,          3,        1,     2880, 0x559247a9
+0,          4,          4,        1,     2880, 0xc3df2cc4
diff --git a/tests/ref/fate/fitsenc-gray16be b/tests/ref/fate/fitsenc-gray16be
new file mode 100644
index 0000000..ec4e0ef
--- /dev/null
+++ b/tests/ref/fate/fitsenc-gray16be
@@ -0,0 +1,10 @@
+#tb 0: 1/1
+#media_type 0: video
+#codec_id 0: fits
+#dimensions 0: 72x36
+#sar 0: 0/1
+0,          0,          0,        1,     5760, 0x317ba180
+0,          1,          1,        1,     5760, 0x439c9e40
+0,          2,          2,        1,     5760, 0x6136ff8f
+0,          3,          3,        1,     5760, 0x2c331324
+0,          4,          4,        1,     5760, 0x2f0816c1